/*
context.js / Teppefall, Jan Erik

Check out com.teppefall.ds.script.ManagerContext for API info.

context.getApplication() - Application handle. context.getApplication().getApplicationFrame() returns primary JFrame.
context.getDarkstar()    - Darkstar 2D instance (Use this to access 2D in FX)
context.getStatus()      - Returns the application status bar.
context.info("Message!")
context.warn("Warning!")
context.status("Hello!")
*/

importPackage(Packages.java.lang)
importPackage(Packages.java.io)
importPackage(Packages.java.awt)
importPackage(Packages.java.awt.geom)
importPackage(Packages.javax.imageio)
importPackage(Packages.com.teppefall.ds.util)
importPackage(Packages.com.teppefall.ds.render2d)
importPackage(Packages.com.teppefall.ds.render2d.compositing)
importPackage(Packages.com.teppefall.dsa.dfx)

var name = context.getApplication().getApplicationName()
var r
if(context.getDarkstar() != null && name == "Teppefall FX") {

var bg = ColorLogic.deriveTransparent(Color.BLUE, 55)
var white = ColorLogic.deriveTransparent(Color.RED, 5)
var fg = Color.WHITE
var gradient = new GradientPaint(10, 60, bg, 90, 40, white, true)
var square = new Rectangle2D.Double(0, 0, 100, 100)
var font = new Font("Arial", Font.BOLD, 18)
//var message = "Surface GFX\u2122"
var message = "Java 2D\u2122"
var layerSize = new Dimension(140, 200)
var blur = new D2DFilterBlur()
var sharpen = new D2DFilterSharpen()

var layerRendering = {
    render : function(g, size) {
    	oc = g.getColor()
    	op = g.getPaint()
        g.setColor(bg)
        square.setRect(0, 0, size.getWidth(), size.getHeight())
        g.setPaint(gradient)
        g.fill(square)
        g.setColor(Color.BLACK)
  //      g.draw(square)
        g.setFont(font)
        g.setColor(fg)
        var currentMessage = message
        g.drawString(
            currentMessage,
            size.width/2-(RenderTools.stringWidth(currentMessage, g)/2),
            (size.height/2)+(font.getSize()/2)
        )
        g.setColor(oc)
        g.setPaint(op)
    }
}

var mainRendering = {
    render : function(g, size) {
        g.setColor(Color.BLACK)
        g.fillRect(0, 0, size.width, size.height)
        x = size.width/2 - layerSize.width/2
        y = size.height/2 - layerSize.height/2
        g.rotate(0.2, size.width, size.height)
        ds.drawLayerAsImage(g, x+30, y+30, layer);
        g.rotate(-0.1, size.width, size.height)
        ds.drawLayerAsImage(g, x+20, y+20, layer);
        g.rotate(-0.1, size.width, size.height)
        ds.drawLayerAsImage(g, x+10, y+10, layer);
    }
}
	var ds = context.getDarkstar()
	var layer = ds.createLayer("test", layerSize, new D2DRenderer(layerRendering))
	//var layer2 = ds.createLayer("test", layerSize, new D2DRenderer(layerRendering))
	ds.setRenderer(new D2DRenderer(mainRendering))
}
else {
	context.info("not fx")
}


/*System.out.println("CONTEXT.JS")
obj = { run: function () { System.out.println("\nrunning"); } }
runnable = new java.lang.Runnable(obj);
thread = new java.lang.Thread(runnable)
thread.start()*/
