<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!--
	Author: Jan Erik Paulsen
	Copyright 2007 Teppefall. All rights reserved. http://www.teppefall.com
-->

<xsl:template match="menubar">
	<void method="add">
		<object class="javax.swing.JMenuBar">
            <xsl:call-template name="id"/>
			<xsl:apply-templates/>
		</object>
	</void>
</xsl:template>

<xsl:template match="menu">
    <void method="add">
        <object class="javax.swing.JMenu">
            <xsl:call-template name="id"/>
            <xsl:call-template name="properties"/>
            <xsl:apply-templates/>
        </object>
    </void>
</xsl:template>

<xsl:template match="menuitem">
    <void method="add">
        <xsl:choose>
            <xsl:when test="@type = 'radiobutton'">
		        <object class="javax.swing.JRadioButtonMenuItem">
		            <xsl:call-template name="id"/>
		            <xsl:call-template name="properties"/>
		        </object>
            </xsl:when>
            <xsl:when test="@type = 'checkbox'">
		        <object class="javax.swing.JCheckBoxMenuItem">
		            <xsl:call-template name="id"/>
		            <xsl:call-template name="properties"/>
		        </object>
            </xsl:when>
            <xsl:otherwise>
		        <object class="javax.swing.JMenuItem">
		            <xsl:call-template name="id"/>
		            <xsl:call-template name="properties"/>
		        </object>
            </xsl:otherwise>
        </xsl:choose>
    </void>
</xsl:template>

<xsl:template match="popupmenu">
	<void method="add">
		<object class="javax.swing.JPopupMenu">
            <xsl:call-template name="id"/>
			<xsl:apply-templates/>
		</object>
	</void>
</xsl:template>

<xsl:template match="separator">
    <void method="add">
        <xsl:choose>
            <xsl:when test="name(parent::*) = 'toolbar'">
		    	<object class="com.teppefall.ds.layout.jxml.AssemblyToolbarSeparator"/>
            </xsl:when>
            <xsl:otherwise>
  				<object class="javax.swing.JSeparator"/>
            </xsl:otherwise>
        </xsl:choose>
	</void>
</xsl:template>

<xsl:template name="id">
	<xsl:if test="@id != ''"><xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>
</xsl:template>


</xsl:stylesheet>